package dao

import (
	"database/sql"
	"fmt"
	"time"
)

const (
	//devDB = "de_records_ctocst"  //空调聊天记录数据表
	// devDB = "de_ctoclog_st"
	//devDB = "de_records"
	// asDB              = "as_records"         //语音助手聊条记录数据表
	arDB = "alarm_remind" //闹钟数据表
	// notsupportTB      = "greenlu_notsupport" //格力NLU不支持的语句
	// errorLog          = "ctoc_errorlog"
	// greenlu_semantic  = "ctoc_greenlu_semantic"
	// tencent_senmantic = "ctoc_tencent_semantic_log"
	// control_semantic  = "ctoc_control_semantic"
	// skillUseDB        = "ctoc_skill_user_like"
	// homeinfoDB        = "de_homeinfo_conn"
	// ctoc_req_ala      = "ctoc_req_ala"
	test_content_url = "test_content_url"
	mid_appkey       = "mid_appkey"
)

const (
	DevRecords = 1 << iota //空调聊天记录标志
	AssRecords             //语音助手聊条记录标志
)

const (
	alarm     = "0"
	remind    = "1"
	countdown = "2"
)

var conn *sql.DB

func GetConn() *sql.DB {
	return conn
}

func InitDB(dsn string) error {
	var err error
	conn, err = sql.Open("mysql", dsn)
	if err != nil {
		//log.Fatalln(err.Error() + " connect database error")
		fmt.Println("ctocst[error]:connect database error!->" + err.Error())

		//LogErrorToFile(logfileError, "database error:" + err.Error())
		return err
	}
	err = conn.Ping()
	if err != nil {
		return err
	}
	conn.SetConnMaxLifetime(time.Minute * 3)
	return nil
	//conn.SetMaxOpenConns(1000)
	//conn.SetMaxIdleConns(500)
}
