package global

import (
	"speech-nlu-parse/pkg/setting"
)

// 设备差异化

var DevLimitedArr []*setting.DevLimitedS

var limitedSetting map[string]*setting.LimitedS

// 临时写死
func InitDevLimitedArr() {
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"default"},
		Limited: setting.LimitedS{
			AlarmNum:           15,
			Recipe:             true,
			FmDomainAlbumList:  []string{"西厢记"},
			Memory:             true,
			Screen:             true,
			HistoryNum:         5,
			IsMusicRemid:       true,
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。",
			ShieldedDomainList: []string{},
		},
	})
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"10f03"},
		Limited: setting.LimitedS{
			AlarmNum:           -1,                         // 设置闹钟的数量限制, -1无限制
			Recipe:             false,                      // 菜谱播报是否受限. 带屏的可以返回菜谱; 无屏进行提示. true:受限(不返回菜谱, 只进行提示), false:不受限(正常返回菜谱)
			FmDomainAlbumList:  []string{"西厢记"},            // fm需要屏蔽的Album, 限制播放的内容
			Memory:             false,                      // 内存是否受限, 无屏语音设备内存受限. true:受限, false:不受限
			Screen:             false,                      // 屏幕是否受限, true:受限(不带屏), false:不受限(带屏)
			HistoryNum:         -1,                         // historyDomain 的条数, 仅在内存受限才生效, 例如"历史的今天" 只会播报五条
			IsMusicRemid:       true,                       // 未授权的情况下是否进行授权提醒提醒, true:提醒, false:不提醒
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。", // MusicRemidText: 您的语音空调尚未激活，请尽快更新格力+APP，进入语音空调语音技能页面，点击QQ音乐进行授权，授权过程不产生任何费用。  # 未授权的设备进行提醒, 替换到腾讯的回复语
			ShieldedDomainList: []string{},                 // 需要进行屏蔽的
		},
	})
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"10f04"},
		Limited: setting.LimitedS{
			AlarmNum:           15,
			Recipe:             true,
			FmDomainAlbumList:  []string{"西厢记"},
			Memory:             true,
			Screen:             true,
			HistoryNum:         5,
			IsMusicRemid:       false,                      // 测试服为true, 正式服为false; 正式服与测试服的也是有差异, 原因: 未切换酷狗音乐. 2022年2月14日11:27:43
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。", // MusicRemidText: 您的语音空调尚未激活，请尽快更新格力+APP，进入语音空调语音技能页面，点击酷狗音乐进行授权，授权过程不产生任何费用。
			ShieldedDomainList: []string{},
		},
	})
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"6400"},
		Limited: setting.LimitedS{
			AlarmNum:           -1,
			Recipe:             true,
			FmDomainAlbumList:  []string{"西厢记"},
			Memory:             false,
			Screen:             true,
			HistoryNum:         5,
			IsMusicRemid:       false,                      // 该mid产品屏蔽了音乐领域, 该项不生效
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。", // 该mid产品屏蔽了音乐领域, 该项不生效
			ShieldedDomainList: []string{"music"},
		},
	})
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"11f06"},
		Limited: setting.LimitedS{
			AlarmNum:           -1,
			Recipe:             false,
			FmDomainAlbumList:  []string{"西厢记"},
			Memory:             false,
			Screen:             false,
			HistoryNum:         -1,
			IsMusicRemid:       false,
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。",
			ShieldedDomainList: []string{},
		},
	})
	DevLimitedArr = append(DevLimitedArr, &setting.DevLimitedS{
		Mids: []string{"10f05"},
		Limited: setting.LimitedS{
			AlarmNum:           -1,
			Recipe:             false,
			FmDomainAlbumList:  []string{"西厢记"},
			Memory:             true,
			Screen:             true,
			HistoryNum:         -1,
			IsMusicRemid:       false,
			MusicRemidText:     "您的设备尚未授权,请前往格力+手机应用绑定授权。",
			ShieldedDomainList: []string{},
		},
	})
}

func InitLimitedSetting() {
	limitedSetting = make(map[string]*setting.LimitedS)
	// 临时写死
	// 删除写死操作
	// InitDevLimitedArr()
	// 初始化
	for i := 0; i < len(DevLimitedArr); i++ {
		for j := 0; j < len(DevLimitedArr[i].Mids); j++ {
			limitedSetting[DevLimitedArr[i].Mids[j]] = &DevLimitedArr[i].Limited
		}
	}
}

// 通过mid获取配置
func GetLimitedSetting(mid string) *setting.LimitedS {
	value, ok := limitedSetting[mid]
	if ok {
		return value
	} else {
		return limitedSetting["default"]
	}
}
