package consul

import (
	"github.com/hashicorp/consul/api"
)

func GetKV(url, token string, paths ...string) []byte {
	config := api.DefaultConfig()
	config.Address = url
	config.Token = token

	client, err := api.NewClient(config)
	if err != nil {
		panic(err)
	}

	var kvContent []byte

	for _, path := range paths {
		kv, _, err := client.KV().Get(path, nil)
		if err != nil {
			panic(err)
		}

		if len(kvContent) > 0 {
			kvContent = append(kvContent, []byte("\n\n")...)
		}
		kvContent = append(kvContent, kv.Value...)
	}

	return kvContent
}
