package tencentNlu

import (
	"speech-nlu-parse/global"
	"speech-nlu-parse/pkg/logger"

	"github.com/tidwall/gjson"
)

// 校验jsonData 键值对
func KeyValueCheck(jsonData []byte) bool {
	if !gjson.GetBytes(jsonData, "header").Exists() {
		global.Logger.WithFields(logger.Fields{"data": map[string]interface{}{"jsonData": jsonData}}).Error("jsonData header is not exist.")
		return false
	}
	if !gjson.GetBytes(jsonData, "payload").Exists() {
		global.Logger.WithFields(logger.Fields{"data": map[string]interface{}{"jsonData": jsonData}}).Error("jsonData payload is not exist.")
		return false
	}

	return true
}
