package tencentNlu

import "speech-nlu-parse/model"

type DomainFuncWs func(*model.DomainParamsWs) []byte

var handlersWs = make(map[string]DomainFuncWs)

func DomainRegisterWs(key string, value DomainFuncWs) {
	handlersWs[key] = value
}

func getHandlerWs(key string) (handler DomainFuncWs, ok bool) {
	handler, ok = handlersWs[key]
	return
}

func registerWs() {
	DomainRegisterWs(WEATHER, weatherDomainWs)
	DomainRegisterWs(WEATHER_YUE, weatherDomainWs)

	DomainRegisterWs(CHAT, chatDomainWs)
	DomainRegisterWs(HOLIDAY, holidayDomainWs)
	DomainRegisterWs(HOLIDAY_YUE, holidayDomainWs)

	DomainRegisterWs(NEWS, newsDomainWs)
	DomainRegisterWs(NEWS_YUE, newsDomainWs)

	DomainRegisterWs(ANCIENTPOEM, ancientpoemDomainWs)
	DomainRegisterWs(ANCIENT_POEM_YUE, ancientpoemDomainWs)

	DomainRegisterWs(SPORTS, sportsDomainWs)
	DomainRegisterWs(SPORTS_YUE, sportsDomainWs)

	DomainRegisterWs(JOKE, jokeDomainWs)
	DomainRegisterWs(JOKE_YUE, jokeDomainWs)

	DomainRegisterWs(ASTRO, astroDomainWs)
	DomainRegisterWs(ASTRO_YUE, astroDomainWs)

	DomainRegisterWs(STOCK, stockDomainWs)
	DomainRegisterWs(STOCK_YUE, stockDomainWs)

	DomainRegisterWs(TRANSLATE, translateDomainWs)
	DomainRegisterWs(TRANSLATE_YUE, translateDomainWs)

	DomainRegisterWs(ALARM, alarmDomainWs)
	DomainRegisterWs(ALARM_YUE, alarmDomainWs)

	DomainRegisterWs(SCIENCE, scienceDomainWs)
	DomainRegisterWs(SCIENCE_YUE, scienceDomainWs)

	DomainRegisterWs(CHENGYU, chengyuDomainWs)
	DomainRegisterWs(CHENGYU_YUE, chengyuDomainWs)

	DomainRegisterWs(REMINDERV2, alarmDomainWs)
	DomainRegisterWs(REMINDER_V2_YUE, alarmDomainWs)

	DomainRegisterWs(GLOBALCTRL3, globalCtrlDomainWs)
	DomainRegisterWs(GLOBALCTRL3_YUE, globalCtrlDomainWs)

	DomainRegisterWs(MEDIACTRL, mediaCtrlDomainWs)
	DomainRegisterWs(MEDIACTRL3_YUE, mediaCtrlDomainWs)

	DomainRegisterWs(BAIKE, baikeDomainWs)

	DomainRegisterWs(FM, fmDomainWs)
	DomainRegisterWs(FM_YUE, fmDomainWs)

	DomainRegisterWs(DEFAULT, defaultDomainWs)
	DomainRegisterWs(MUSIC, musicDomainWs)
	DomainRegisterWs(MUSIC_YUE, musicDomainWs)

	DomainRegisterWs(VOLUMECTRL3, volumeCtrl3DomainWs)
	DomainRegisterWs(VOLUMECTRL3_YUE, volumeCtrl3DomainWs)

	DomainRegisterWs(SCREENCONTROL, screenCtrlDomainWs)
	DomainRegisterWs(WORLDRECORDSQAPAIRS, worldRecordsQaPairsDomainWs)
	DomainRegisterWs(LLM, llmDomainWs) // 腾讯大语言模型bot
	DomainRegisterWs(SOUND, soundDomainWs)
	DomainRegisterWs(SOUND_YUE, soundDomainWs)

	DomainRegisterWs(GEOGRAPHYKBQA, geographyKbqaDomainWs)
	DomainRegisterWs(GENERALQUESTIONANSWERING, generalAuestionAnsweringDomainWs)
	DomainRegisterWs(HTWHYS_QA_PAIRS, htwhysQaPairsDomainWs)
	DomainRegisterWs(INVENTION_QA_PAIRS, inventionQaPairsDomainWs)
	DomainRegisterWs(GEOGRAPHY, universalDomainWs)
	// DomainRegisterWs(FINANCE, universalDomainWs)
	DomainRegisterWs(HELP, universalDomainWs)
	DomainRegisterWs(HELP_YUE, universalDomainWs)

	DomainRegisterWs(ALMANAC, universalDomainWs)
	DomainRegisterWs(CITYINFO, universalDomainWs)
	DomainRegisterWs(HISTORY, universalDomainWs)
	DomainRegisterWs(RECIPE, universalDomainWs)
	DomainRegisterWs(DISEASE, universalDomainWs)
	DomainRegisterWs(GARBAGECLASS, universalDomainWs)
	DomainRegisterWs(ASTRONOMY_KBQA, universalDomainWs)
	DomainRegisterWs(COMMON_QA_QA_PAIRS, universalDomainWs)
	DomainRegisterWs(XIAOLIAO, universalDomainWs)
	DomainRegisterWs(MCHAT, universalDomainWs)
	DomainRegisterWs(GLETKT_XLCJ_1245258905417052160, universalDomainWs)
	DomainRegisterWs(CESHI_1149914105856290816, universalDomainWs)
	DomainRegisterWs(GELIYOUPINGKONGTIAO_1289106967398617088, universalDomainWs)
	DomainRegisterWs(JHDPBXZSWD_1364089899207012352, universalDomainWs)
	DomainRegisterWs(LXTEST_1697504067777118921, universalDomainWs)
	DomainRegisterWs(LXTEST_1697504245166677379, universalDomainWs)
	DomainRegisterWs(LCHAT_1736631343458063755, universalDomainWs)

}
