package tencentNlu

import "speech-nlu-parse/model"

type DomainFuncV2 func(*model.DomainParamsV2) []byte

var handlersV2 = make(map[string]DomainFuncV2)

func DomainRegisterV2(key string, value DomainFuncV2) {
	handlersV2[key] = value
}

func getHandlerV2(key string) (handler DomainFuncV2, ok bool) {
	handler, ok = handlersV2[key]
	return
}

func registerV2() {
	DomainRegisterV2(WEATHER, weatherDomainV2)
	DomainRegisterV2(CHAT, chatDomainV2)
	DomainRegisterV2(MCHAT, chatDomainV2) // mchat
	DomainRegisterV2(HOLIDAY, holidayDomainV2)
	DomainRegisterV2(NEWS, newsDomainV2)
	DomainRegisterV2(ANCIENTPOEM, ancientpoemDomainV2)
	DomainRegisterV2(SPORTS, sportsDomainV2)
	DomainRegisterV2(JOKE, jokeDomainV2)
	DomainRegisterV2(ASTRO, astroDomainV2)
	DomainRegisterV2(STOCK, stockDomainV2)
	DomainRegisterV2(TRANSLATE, translateDomainV2)
	DomainRegisterV2(ALARM, alarmDomainV2)
	DomainRegisterV2(SCIENCE, scienceDomainV2)
	DomainRegisterV2(CHENGYU, chengyuDomainV2)
	DomainRegisterV2(REMINDERV2, alarmDomainV2)
	DomainRegisterV2(GLOBALCTRL3, globalCtrlDomainV2)
	DomainRegisterV2(MEDIACTRL, mediaCtrlDomainV2)
	DomainRegisterV2(BAIKE, baikeDomainV2)
	DomainRegisterV2(FM, fmDomainV2)
	DomainRegisterV2(DEFAULT, defaultDomainV2)
	DomainRegisterV2(MUSIC, musicDomainV2)
	DomainRegisterV2(VOLUMECTRL3, volumeCtrl3DomainV2)
	DomainRegisterV2(SCREENCONTROL, screenCtrlDomainV2)
	DomainRegisterV2(WORLDRECORDSQAPAIRS, worldRecordsQaPairsDomainV2)

}
